Open CASCADE Technology  7.7.0.dev
Public Member Functions | Static Public Member Functions

ShapeAnalysis_Curve Class Reference

Analyzing tool for 2d or 3d curve. Computes parameters of projected point onto a curve. More...

#include <ShapeAnalysis_Curve.hxx>

Public Member Functions

Standard_Real Project (const Handle< Geom_Curve > &C3D, const gp_Pnt &P3D, const Standard_Real preci, gp_Pnt &proj, Standard_Real &param, const Standard_Boolean AdjustToEnds=Standard_True) const
 Projects a Point on a Curve. Computes the projected point and its parameter on the curve. <preci> is used as 3d precision (hence, 0 will produce reject unless exact confusion). The number of iterations is limited. If AdjustToEnds is True, point will be adjusted to the end of the curve if distance is less than <preci> More...
 
Standard_Real Project (const Adaptor3d_Curve &C3D, const gp_Pnt &P3D, const Standard_Real preci, gp_Pnt &proj, Standard_Real &param, const Standard_Boolean AdjustToEnds=Standard_True) const
 Projects a Point on a Curve. Computes the projected point and its parameter on the curve. <preci> is used as 3d precision (hence, 0 will produce reject unless exact confusion). The number of iterations is limited. More...
 
Standard_Real Project (const Handle< Geom_Curve > &C3D, const gp_Pnt &P3D, const Standard_Real preci, gp_Pnt &proj, Standard_Real &param, const Standard_Real cf, const Standard_Real cl, const Standard_Boolean AdjustToEnds=Standard_True) const
 Projects a Point on a Curve, but parameters are limited between <cf> and <cl>. The range [cf, cl] is extended with help of Adaptor3d on the basis of 3d precision <preci>. If AdjustToEnds is True, point will be adjusted to the end of the curve if distance is less than <preci> More...
 
Standard_Real ProjectAct (const Adaptor3d_Curve &C3D, const gp_Pnt &P3D, const Standard_Real preci, gp_Pnt &proj, Standard_Real &param) const
 
Standard_Real NextProject (const Standard_Real paramPrev, const Handle< Geom_Curve > &C3D, const gp_Pnt &P3D, const Standard_Real preci, gp_Pnt &proj, Standard_Real &param, const Standard_Real cf, const Standard_Real cl, const Standard_Boolean AdjustToEnds=Standard_True) const
 Projects a Point on a Curve using Newton method. <paramPrev> is taken as the first approximation of solution. If Newton algorithm fails the method Project() is used. If AdjustToEnds is True, point will be adjusted to the end of the curve if distance is less than <preci> More...
 
Standard_Real NextProject (const Standard_Real paramPrev, const Adaptor3d_Curve &C3D, const gp_Pnt &P3D, const Standard_Real preci, gp_Pnt &proj, Standard_Real &param) const
 Projects a Point on a Curve using Newton method. <paramPrev> is taken as the first approximation of solution. If Newton algorithm fails the method Project() is used. More...
 
Standard_Boolean ValidateRange (const Handle< Geom_Curve > &Crv, Standard_Real &First, Standard_Real &Last, const Standard_Real prec) const
 Validate parameters First and Last for the given curve in order to make them valid for creation of edge. This includes: More...
 
void FillBndBox (const Handle< Geom2d_Curve > &C2d, const Standard_Real First, const Standard_Real Last, const Standard_Integer NPoints, const Standard_Boolean Exact, Bnd_Box2d &Box) const
 Computes a boundary box on segment of curve C2d from First to Last. This is done by taking NPoints points from the curve and, if Exact is True, by searching for exact extrema. All these points are added to Box. More...
 
Standard_Integer SelectForwardSeam (const Handle< Geom2d_Curve > &C1, const Handle< Geom2d_Curve > &C2) const
 Defines which pcurve (C1 or C2) should be chosen for FORWARD seam edge. More...
 

Static Public Member Functions

static Standard_Boolean IsPlanar (const TColgp_Array1OfPnt &pnts, gp_XYZ &Normal, const Standard_Real preci=0)
 Checks if points are planar with given preci. If Normal has not zero modulus, checks with given normal. More...
 
static Standard_Boolean IsPlanar (const Handle< Geom_Curve > &curve, gp_XYZ &Normal, const Standard_Real preci=0)
 Checks if curve is planar with given preci. If Normal has not zero modulus, checks with given normal. More...
 
static Standard_Boolean GetSamplePoints (const Handle< Geom2d_Curve > &curve, const Standard_Real first, const Standard_Real last, TColgp_SequenceOfPnt2d &seq)
 Returns sample points which will serve as linearisation of the2d curve in range (first, last) The distribution of sample points is consystent with what is used by BRepTopAdaptor_FClass2d. More...
 
static Standard_Boolean GetSamplePoints (const Handle< Geom_Curve > &curve, const Standard_Real first, const Standard_Real last, TColgp_SequenceOfPnt &seq)
 Returns sample points which will serve as linearisation of the curve in range (first, last) More...
 
static Standard_Boolean IsClosed (const Handle< Geom_Curve > &curve, const Standard_Real preci=-1)
 Tells if the Curve is closed with given precision. If <preci> < 0 then Precision::Confusion is used. More...
 
static Standard_Boolean IsPeriodic (const Handle< Geom_Curve > &curve)
 This method was implemented as fix for changes in trimmed curve behaviour. For the moment trimmed curve returns false anyway. So it is necessary to adapt all Data exchange tools for this behaviour. Current implementation takes into account that curve may be offset. More...
 
static Standard_Boolean IsPeriodic (const Handle< Geom2d_Curve > &curve)
 The same as for Curve3d. More...
 

Detailed Description

Analyzing tool for 2d or 3d curve. Computes parameters of projected point onto a curve.

Member Function Documentation

◆ FillBndBox()

void ShapeAnalysis_Curve::FillBndBox ( const Handle< Geom2d_Curve > &  C2d,
const Standard_Real  First,
const Standard_Real  Last,
const Standard_Integer  NPoints,
const Standard_Boolean  Exact,
Bnd_Box2d Box 
) const

Computes a boundary box on segment of curve C2d from First to Last. This is done by taking NPoints points from the curve and, if Exact is True, by searching for exact extrema. All these points are added to Box.

◆ GetSamplePoints() [1/2]

static Standard_Boolean ShapeAnalysis_Curve::GetSamplePoints ( const Handle< Geom2d_Curve > &  curve,
const Standard_Real  first,
const Standard_Real  last,
TColgp_SequenceOfPnt2d seq 
)
static

Returns sample points which will serve as linearisation of the2d curve in range (first, last) The distribution of sample points is consystent with what is used by BRepTopAdaptor_FClass2d.

◆ GetSamplePoints() [2/2]

static Standard_Boolean ShapeAnalysis_Curve::GetSamplePoints ( const Handle< Geom_Curve > &  curve,
const Standard_Real  first,
const Standard_Real  last,
TColgp_SequenceOfPnt seq 
)
static

Returns sample points which will serve as linearisation of the curve in range (first, last)

◆ IsClosed()

static Standard_Boolean ShapeAnalysis_Curve::IsClosed ( const Handle< Geom_Curve > &  curve,
const Standard_Real  preci = -1 
)
static

Tells if the Curve is closed with given precision. If <preci> < 0 then Precision::Confusion is used.

◆ IsPeriodic() [1/2]

static Standard_Boolean ShapeAnalysis_Curve::IsPeriodic ( const Handle< Geom2d_Curve > &  curve)
static

The same as for Curve3d.

◆ IsPeriodic() [2/2]

static Standard_Boolean ShapeAnalysis_Curve::IsPeriodic ( const Handle< Geom_Curve > &  curve)
static

This method was implemented as fix for changes in trimmed curve behaviour. For the moment trimmed curve returns false anyway. So it is necessary to adapt all Data exchange tools for this behaviour. Current implementation takes into account that curve may be offset.

◆ IsPlanar() [1/2]

static Standard_Boolean ShapeAnalysis_Curve::IsPlanar ( const Handle< Geom_Curve > &  curve,
gp_XYZ Normal,
const Standard_Real  preci = 0 
)
static

Checks if curve is planar with given preci. If Normal has not zero modulus, checks with given normal.

◆ IsPlanar() [2/2]

static Standard_Boolean ShapeAnalysis_Curve::IsPlanar ( const TColgp_Array1OfPnt pnts,
gp_XYZ Normal,
const Standard_Real  preci = 0 
)
static

Checks if points are planar with given preci. If Normal has not zero modulus, checks with given normal.

◆ NextProject() [1/2]

Standard_Real ShapeAnalysis_Curve::NextProject ( const Standard_Real  paramPrev,
const Adaptor3d_Curve C3D,
const gp_Pnt P3D,
const Standard_Real  preci,
gp_Pnt proj,
Standard_Real param 
) const

Projects a Point on a Curve using Newton method. <paramPrev> is taken as the first approximation of solution. If Newton algorithm fails the method Project() is used.

◆ NextProject() [2/2]

Standard_Real ShapeAnalysis_Curve::NextProject ( const Standard_Real  paramPrev,
const Handle< Geom_Curve > &  C3D,
const gp_Pnt P3D,
const Standard_Real  preci,
gp_Pnt proj,
Standard_Real param,
const Standard_Real  cf,
const Standard_Real  cl,
const Standard_Boolean  AdjustToEnds = Standard_True 
) const

Projects a Point on a Curve using Newton method. <paramPrev> is taken as the first approximation of solution. If Newton algorithm fails the method Project() is used. If AdjustToEnds is True, point will be adjusted to the end of the curve if distance is less than <preci>

◆ Project() [1/3]

Standard_Real ShapeAnalysis_Curve::Project ( const Adaptor3d_Curve C3D,
const gp_Pnt P3D,
const Standard_Real  preci,
gp_Pnt proj,
Standard_Real param,
const Standard_Boolean  AdjustToEnds = Standard_True 
) const

Projects a Point on a Curve. Computes the projected point and its parameter on the curve. <preci> is used as 3d precision (hence, 0 will produce reject unless exact confusion). The number of iterations is limited.

Returned value is the distance between the given point and computed one.

◆ Project() [2/3]

Standard_Real ShapeAnalysis_Curve::Project ( const Handle< Geom_Curve > &  C3D,
const gp_Pnt P3D,
const Standard_Real  preci,
gp_Pnt proj,
Standard_Real param,
const Standard_Boolean  AdjustToEnds = Standard_True 
) const

Projects a Point on a Curve. Computes the projected point and its parameter on the curve. <preci> is used as 3d precision (hence, 0 will produce reject unless exact confusion). The number of iterations is limited. If AdjustToEnds is True, point will be adjusted to the end of the curve if distance is less than <preci>

Returned value is the distance between the given point and computed one.

◆ Project() [3/3]

Standard_Real ShapeAnalysis_Curve::Project ( const Handle< Geom_Curve > &  C3D,
const gp_Pnt P3D,
const Standard_Real  preci,
gp_Pnt proj,
Standard_Real param,
const Standard_Real  cf,
const Standard_Real  cl,
const Standard_Boolean  AdjustToEnds = Standard_True 
) const

Projects a Point on a Curve, but parameters are limited between <cf> and <cl>. The range [cf, cl] is extended with help of Adaptor3d on the basis of 3d precision <preci>. If AdjustToEnds is True, point will be adjusted to the end of the curve if distance is less than <preci>

◆ ProjectAct()

Standard_Real ShapeAnalysis_Curve::ProjectAct ( const Adaptor3d_Curve C3D,
const gp_Pnt P3D,
const Standard_Real  preci,
gp_Pnt proj,
Standard_Real param 
) const

◆ SelectForwardSeam()

Standard_Integer ShapeAnalysis_Curve::SelectForwardSeam ( const Handle< Geom2d_Curve > &  C1,
const Handle< Geom2d_Curve > &  C2 
) const

Defines which pcurve (C1 or C2) should be chosen for FORWARD seam edge.

◆ ValidateRange()

Standard_Boolean ShapeAnalysis_Curve::ValidateRange ( const Handle< Geom_Curve > &  Crv,
Standard_Real First,
Standard_Real Last,
const Standard_Real  prec 
) const

Validate parameters First and Last for the given curve in order to make them valid for creation of edge. This includes:

  • limiting range [First,Last] by range of curve
  • adjusting range [First,Last] for periodic (or closed) curve if Last < First Returns True if parameters are OK or are successfully corrected, or False if parameters cannot be corrected. In the latter case, parameters are reset to range of curve.

The documentation for this class was generated from the following file: